﻿using UnityEngine;
using System.Collections;

// 銃の装備などの役割を持つ
public class GunController : MonoBehaviour
{
	// 装備する位置
	public Transform weaponHold;
	public Gun[] allGuns;
	// 装備中の銃
	Gun equippedGun;

	void Start ()
	{
	}

	public void EquipGun (Gun gunToEquip)
	{
		if (equippedGun != null) {
			Destroy (equippedGun.gameObject);
		}
		// weaponHoldの場所にインスタンス生成。この時点では、プレイヤーのweaponHoldにつながっていない。
		equippedGun = Instantiate (gunToEquip, weaponHold.position, weaponHold.rotation) as Gun;
		// Gunの親オブジェクトをPlayerの子要素のweaponHoldに設定
		equippedGun.transform.parent = weaponHold;
	}

	public void EquipGun (int weaponIndex)
	{
		EquipGun (allGuns [weaponIndex]);
	}

	public void OnTriggerHold ()
	{
		if (equippedGun != null) {
			equippedGun.OnTriggerHold ();
		}
	}

	public void OnTriggerRelease ()
	{
		if (equippedGun != null) {
			equippedGun.OnTriggerRelease ();
		}
	}

	public float GunHeight {
		get {
			return weaponHold.position.y;
		}
	}

	public void Aim (Vector3 aimPoint)
	{
		if (equippedGun != null) {
			equippedGun.Aim (aimPoint);
		}
	}

	public void Reload ()
	{
		if (equippedGun != null) {
			equippedGun.Reload ();
		}
	}
}
