﻿using UnityEngine;
using System.Collections;
using UnityEngine.SceneManagement;

public class MusicManager : MonoBehaviour
{
	public AudioClip mainTheme;
	public AudioClip menuTheme;

	string sceneName;

	// http://answers.unity3d.com/questions/1113539/onlevelwasloaded-after-awake-unity-53.html
	void Start ()
	{
		// Unity5.3で最初のシーンは、OnLevelWasLoadedが呼ばれない。
		OnLevelWasLoaded (0);
	}

	void OnLevelWasLoaded (int sceneIndex)
	{
		Debug.Log ("OnLevelWasLoaded");
		string newSceneName = SceneManager.GetActiveScene ().name;
		if (newSceneName != sceneName) {
			sceneName = newSceneName;
			Invoke ("PlayMusic", .2f);
		}
	}

	void PlayMusic ()
	{
		AudioClip clipToPlay = null;
		if (sceneName == "Menu") {
			clipToPlay = menuTheme;
		} else if (sceneName == "Game") {
			clipToPlay = mainTheme;
		}

		if (clipToPlay != null) {
			AudioManager.instance.PlayMusic (clipToPlay, 2);
			Invoke ("PlayMusic", clipToPlay.length); // Loop music.
		}
	}
}
