﻿using UnityEngine;
using System.Collections;

public class ScoreKeeper : MonoBehaviour
{
	public static int score { get; private set; }

	float lastEnemyKillTime;
	int streakCount;
	float streakExpiryTime = 1;

	void Start ()
	{
		Debug.Log ("called ScoreKeeper.Start");
		Enemy.OnDeathStatic += OnEnemyKilled;
		// このゲームはプレイヤーが死んだら、最初のステージがリロードされる。
		// シーン上のEnemyクラスに設定したOnDeathStaticは消えないので、
		// 放置すると二重登録になってしまうので、プレイヤーが死んだときに解除する。
		FindObjectOfType<Player> ().OnDeath += OnPlayerDeath;
	}

	void OnEnemyKilled ()
	{
		// チェーンが続いている
		if (Time.time < lastEnemyKillTime + streakExpiryTime) {
			streakCount++;
		} else {
			streakCount = 0;
		}

		lastEnemyKillTime = Time.time;

		score += 5 + (int)Mathf.Pow (2, streakCount);
	}

	void OnPlayerDeath ()
	{
		Enemy.OnDeathStatic -= OnEnemyKilled;
	}
}
